package com.nmbb;

import java.lang.reflect.Constructor;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import com.nmbb.a.R;

import dalvik.system.DexClassLoader;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager.NameNotFoundException;
import android.content.res.Resources;
import android.graphics.drawable.Drawable;
import android.os.Bundle;
import android.os.Environment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TextView;
import android.widget.Toast;

public class TestAActivity extends Activity {

	/** TestB */
	private static final String PACKAGE_TEST_B = "com.nmbb.b";

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		try {
			final Context ctxTestB = getTestBContext();
			Resources res = ctxTestB.getResources();
			// ȡַstring
			String hello = res.getString(getId(res, "string", "hello"));
			((TextView) findViewById(R.id.testb_string)).setText(hello);

			// ȡͼƬDrawable
			Drawable drawable = res
					.getDrawable(getId(res, "drawable", "testb"));
			((ImageView) findViewById(R.id.testb_drawable))
					.setImageDrawable(drawable);

			// ȡɫֵ
			int color = res.getColor(getId(res, "color", "white"));
			((TextView) findViewById(R.id.testb_color))
					.setBackgroundColor(color);

			// ȡļ
			View view = getView(ctxTestB, getId(res, "layout", "main"));
			LinearLayout layout = (LinearLayout) findViewById(R.id.testb_layout);
			layout.addView(view);

			// TestB Activity
			findViewById(R.id.testb_activity).setOnClickListener(
					new OnClickListener() {
						@Override
						public void onClick(View v) {
							try {
								@SuppressWarnings("rawtypes")
								Class cls = ctxTestB.getClassLoader()
										.loadClass("com.nmbb.TestBActivity");
								startActivity(new Intent(ctxTestB, cls));
							} catch (ClassNotFoundException e) {
								e.printStackTrace();
							}
						}
					});
		} catch (NameNotFoundException e) {
			e.printStackTrace();
		}
	}

	/**
	 * ȡԴӦı
	 * 
	 * @param testb
	 * @param resName
	 * @param resType
	 *            layoutdrawablestring
	 * @return
	 */
	private int getId(Resources testb, String resType, String resName) {
		return testb.getIdentifier(resName, resType, PACKAGE_TEST_B);
	}

	/**
	 * ȡͼ
	 * 
	 * @param ctx
	 * @param id
	 * @return
	 */
	public View getView(Context ctx, int id) {
		return ((LayoutInflater) ctx
				.getSystemService(Context.LAYOUT_INFLATER_SERVICE)).inflate(id,
				null);
	}

	/**
	 * ȡTestBContext
	 * 
	 * @return
	 * @throws NameNotFoundException
	 */
	private Context getTestBContext() throws NameNotFoundException {
		return createPackageContext(PACKAGE_TEST_B,
				Context.CONTEXT_IGNORE_SECURITY | Context.CONTEXT_INCLUDE_CODE);
	}

	/**
	 * Բװ̬ô
	 */
	private void test1() {
		String path = Environment.getExternalStorageDirectory() + "/";
		String filename = "TestB.apk";
		DexClassLoader classLoader = new DexClassLoader(path + filename, path,
				null, getClassLoader());

		try {
			Class mLoadClass = classLoader.loadClass("com.nmbb.TestBActivity");
			Constructor constructor = mLoadClass.getConstructor(new Class[] {});
			Object TestBActivity = constructor.newInstance(new Object[] {});

			Method getMoney = mLoadClass.getMethod("getMoney", null);
			getMoney.setAccessible(true);
			Object money = getMoney.invoke(TestBActivity, null);
			Toast.makeText(this, money.toString(), Toast.LENGTH_LONG).show();

		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		} catch (SecurityException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			e.printStackTrace();
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (InstantiationException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		}
	}

}